<template>
    <div>
        <div class="mrg-b">
            <el-row>
                <el-col :span="21">
                <el-button v-auth="50500040104" type="primary" @click="handlePicking">加工确认</el-button>
                <el-button v-auth="50500040105" type="primary" @click="handleCancelPickking">取消加工</el-button>
                <el-button v-auth="50500040109" type="primary" @click="handlePickkingTask">生成上架任务</el-button>
                </el-col>
                <el-col :span="3">
                <!-- <el-col :span="15">
                    <el-input v-model="query.quickCondition" @keyup.enter.native="handleSearch" placeholder="快捷查询(加工单号)"></el-input>
                </el-col> -->
                <el-col class="mrg-l">
                    <el-button v-auth="50500040108" type="primary" @click="handleMoreSearch">更多</el-button>
                    <el-button v-auth="50500040101" icon="el-icon-refresh" class="query__item" type="primary" @click="handleSearch" plain circle></el-button>
                    <el-button
                    v-if="false"
                      icon="el-icon-download"
                      type="primary"
                      @click="handleExcel"
                      plain
                      circle
                    ></el-button>
                </el-col>
                </el-col>
            </el-row>
        </div>
         <div class="inputBox">
            <el-form inline :model="formData" ref="formData" label-position="left">
                <el-form-item label="加工单号" prop="kitNo">
                  <el-input v-model="formData.kitNo" @keyup.enter.native="handelkitNo"></el-input>
                </el-form-item>
                <el-form-item
                  label="状态"
                  prop="status">
                  <el-select multiple v-model="status" @change="val => handleStatus(val)">
                    <el-option label="创建" value="00"></el-option>
                    <el-option label="部分加工" value="70"></el-option>
                    <el-option label="完全加工" value="80"></el-option>
                    <el-option label="取消订单" value="90"></el-option>
                    <el-option label="关闭订单" value="99"></el-option>
                  </el-select>
                </el-form-item>
                 <el-form-item
                  label="组合件类型"
                  prop="kitType">
                  <el-select v-model="formData.kitType" @change="handelkitNo">
                      <el-option label="组合加工(A=B+C)" value="COM"></el-option>
                      <el-option label="辅料加工(A=A+辅料)" value="ACC"></el-option>
                      <el-option label="增值加工(A=A)" value="VA"></el-option>
                  </el-select>
                  </el-form-item>
             </el-form>
        </div>
        <more-query
        :moreQueryVisible="moreQueryVisible"
        @close="moreQueryVisible=false"
        @toGetList="getQueryList">
        </more-query>

    </div>
</template>
<script>
import MoreQuery from './more-query'
export default {
  components: {
    MoreQuery
  },
  data () {
    return {
      query: {},
      moreQueryVisible: false,
      formData: {},
      status: '',
      moreData: {}
    }
  },
  props: {
    selectedIds: Array,
  },
  methods: {
    getParam () {
      const formData = { ...this.formData, kitNo: `%${this.formData.kitNo}%` }
      return formData
    },
    handelkitNo () {
      this.$emit('getList', this.getParam())
    },
    handleStatus (val) {
      this.formData.status = val.join(',')
      this.$emit('getList', this.getParam())
    },
    // 检查是否选中行
    checkSelections () {
      if (!this.selectedIds.length) {
        this.$message.error('请选择记录')
        return false
      } else {
        return true
      }
    },

    // 搜索查询
    handleSearch () {
      this.$refs.formData.resetFields()
      this.status = []
      this.$emit('getList')
    },

    // 更多查询数据
    getQueryList (query) {
      this.moreQueryVisible = false
      this.moreData = query
      this.$emit('getList', query)
    },

    // 更多搜索查询
    handleMoreSearch () {
      this.moreQueryVisible = true
    },

    // 打印
    toPrint (command, vmNode) {
      if (this.checkSelections()) {
        const param = {
          title: vmNode.$el.innerHTML,
          qs: `_functionCode=${command}&kitNo=${this.selectedIds.join(';')}`
        }
        this.$print(param)
      }
    },
    handlePicking () {
      console.log(this.selectedIds)
      if (!this.selectedIds.length) {
        return this.$message.error('请选择记录')
      }
      const url = this.$API.maintain.KitBomKitConfirmList.kitControll
      const param = { kitNos: JSON.stringify(this.selectedIds) }
      this.$https.post(url, param).then(res => {
        this.$emit('getList', this.query)
      })
    },
    handleCancelPickking () {
      if (!this.selectedIds.length) {
        return this.$message.error('请选择记录')
      }
      const url = this.$API.maintain.KitBomKitConfirmList.kitCancelConfirm
      const param = { kitNos: JSON.stringify(this.selectedIds) }
      this.$https.post(url, param).then(res => {
        this.$emit('getList', this.query)
      })
    },
    handlePickkingTask () {
      if (!this.selectedIds.length) {
        return this.$message.error('请选择记录')
      }
      const url = this.$API.maintain.KitBomKitConfirmList.createTaskPa
      const param = { kitNos: JSON.stringify(this.selectedIds) }
      this.$https.post(url, param).then(res => {
        this.$emit('getList', this.query)
      })
    },
    handleExcel () {
      const url = this.$API.maintain.KitBomKitConfirmList.getList
      const options = this.moreData
      this.$exportExcel(url, options)
    },
  }
}
</script>
<style lang="scss" scoped>
    .inputBox {
      width: 100%;
      border: 1px solid #d1d5db;
      margin-top: 10px;
      margin-bottom: 10px;
      border-radius: 10px;
      padding-bottom: 10px;
      padding-left: 10px;
      .el-form-item {
        margin-bottom: 0px;
        margin-top: 10px;
      }
    }
    .mrg-b{
        margin-bottom: 20px;
    }
    .mrg-l{
        margin-left:10px;
    }
  .query {
    &__operations {
      float: left;
    }
    &__retrieve {
      float: right;
      .el-input {
        max-width: 180px;
      }
    }
    &__item {
      margin-left: 10px;
    }
  }
</style>
